(defun C:NoNameBlock ( / )
  
(renameBlock "" "neuerName")
)

(defun renameBlock (oldname newname / blockrecord)
  (if (setq blockrecord (getblockrecord oldname))
    (progn
    (entmod
      (subst (cons 2 newname) (cons 2 oldname) blockrecord)
      ) ;_ end of entmod
    (prompt "\nUnbenannter Block in 'neuerName' umbenannt!")
    ) ;_ end of progn
    ) ;_ end of if
  ) ;_ end of defun

(defun getblockrecord (name / rslt e h i d)
  (setq name (strcase name))
  (cond ((setq e (tblobjname "block" name))
         (setq h (cdr (assoc 5 (entget e))))
         (setq i (hex2int h))
         (while (and (not rslt) (> i 0))
           (setq h (int2hex (setq i (1- i))))
           (if (setq e (handent h))
             (if (setq d (entget e))
               (if (eq "BLOCK_RECORD" (cdr (assoc 0 d)))
                 (if (eq name (cdr (assoc 2 d)))
                   (setq rslt d)
                   ) ;_ end of if
                 ) ;_ end of if
               ) ;_ end of if
             ) ;_ end of if
           ) ;_ end of while
         )
        ) ;_ end of cond
  ) ;_ end of defun

(defun int2hex (n / h i)
  (setq h "")
  (while (< 0 n)
    (setq h (strcat
              (if (> (setq i (rem n 16)) 9)
                (chr (+ 55 i))
                (chr (+ 48 i))
                ) ;_ end of if
              h
              ) ;_ end of strcat
          n (/ n 16)
          ) ;_ end of setq
    ) ;_ end of while
  (while (= (substr h 1 1) "0") (setq h (substr h 2)))
  h
  ) ;_ end of defun


(defun hex2int (h / p n i)
  (setq i 0
        h (strcase h)
        p (strcat "\nHex2Int error. Invalid <" h ">.")
        ) ;_ end of setq
  (while (/= 0
             (setq n (substr h 1 1)
                   h (substr h 2)
                   n (ascii n)
                   ) ;_ end of setq
             ) ;_ end of /=
    (if (setq n
               (cond ((< n 48) (princ p))
                     ((< n 58) (- n 48))
                     ((< n 65) (princ p))
                     ((< n 71) (- n 55))
                     (T (princ p))
                     ) ;_ end of cond
              ) ;_ end of setq
      (setq i (+ i (* (expt 16 (strlen h)) n)))
      ) ;_ end of if
    ) ;_ end of while
  i
  ) ;_ end of defun


;(setq block_wanted (tblsearch "block" "")) > ((0 . "BLOCK") (2 . "") (70 . 0) (10 1601.6 1963.03 0.0) (-2 . <Entity name: > 58b0518>)) > > 2nd method > (setq block_wanted (entget (tblobjname "block" ""))) > ((-1 . <Entity name: 58b0540>) (0 . "BLOCK") (5 . "28") (100 . "AcDbEntity") > (67 . 0) (8 . "INCENDIE") (100 . "AcDbBlockBegin") (70 . 0) (10 1601.6 > 1963.03 > 0.0) (-2 . <Entity name: 58b0518>) (2 . "") (3 . "")) 
;|Visual LISP Format Options
(72 2 40 1 T "end of " 60 9 0 0 0 nil T nil T)
;*** KEINEN Text unterhalb des Kommentars hinzufgen! ***|;
